﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.BioBoost.Representation;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Core;
using HeuristicLab.Common;
using HeuristicLab.Data;

namespace HeuristicLab.BioBoost.Evaluators {
  [StorableClass]
  [Item("InitializationEvaluator", "Cleans up scope.")]
  public class InitializationEvaluator : BioBoostEvaluator {

    #region Construction & Cloning
    [StorableConstructor]
    protected InitializationEvaluator(bool isDeserializing) : base(isDeserializing) {}
    protected InitializationEvaluator(InitializationEvaluator original, Cloner cloner) : base(original, cloner) { }
    public InitializationEvaluator() { }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new InitializationEvaluator(this, cloner);
    }
    #endregion

    public override IOperation Apply() {
      var vars = new List<string>();
      foreach(var var in ExecutionContext.Scope.Variables) {
        vars.Add(var.Name);
      }    
      foreach (var var in vars) {
        if (!LayerDescriptor.TransportTargets.IsSuffixOf(var) &&
            !LayerDescriptor.Utilizations.IsSuffixOf(var) &&
            var != "IntermediateResults" &&
            var != "Costs" &&
            !var.StartsWith("Selected")) {
          RemoveFromScope(var);
        }
      }
       ;
      //var var = new Variable(label, value);
      //if (vars.ContainsKey(label))
      //  vars.Remove(label);

     // RemoveFromScope(feedstock + BioBoostProblem.AmountsAtTargetName);

      return base.Apply();
    }
  }
}
