﻿using SharpMap.Data;
using SharpMap.Data.Providers;
using System.Data;
using System.IO;
using System.Linq;

namespace HeuristicLab.BioBoost.Persistence {

  public static class ShapeFileLoader {
    public static GeometryFeatureProvider LoadShapeFile(string filename) {
      var shapefile = new ShapeFile(filename, true, true);
      shapefile.Open();
      var table = new FeatureDataTable {TableName = Path.GetFileNameWithoutExtension(shapefile.Filename)};
      bool addColumns = true;
      foreach (var row in shapefile.GetObjectIDsInView(shapefile.GetExtents()).Select(shapefile.GetFeature)) {
        if (addColumns && row.Table != null) {
          foreach (DataColumn col in row.Table.Columns)
            table.Columns.Add(col.ColumnName, col.DataType);
          addColumns = false;
        }
        var newRow = (FeatureDataRow) table.LoadDataRow(row.ItemArray, LoadOption.OverwriteChanges);
        newRow.Geometry = row.Geometry;
      }
      return new GeometryFeatureProvider(table);
    }
  }
}
